
var   flipShown = false;
var   diffShown = false; 
var   dayoffset = 0;
var  weekoffset = 0;
var monthoffset = 0;
var        show = 0;

// main initialization

function setupWidget() 
{
  back.style.display="none";

  var doneButton = document.getElementById('done');
	
  createGenericButton (doneButton, getLocalizedString('Done'), selectDone);
	
  doneButton.childNodes[1].style.minWidth = '47px';
  
  document.getElementById('result').innerText = 'difference: 0 days 0 months 0 years';
  document.getElementById('days').value = '0';
  document.getElementById('weeks').value = '0';
  document.getElementById('months').value = '0';
  document.getElementById('ver').innerText = '1.4';
}

function onshown () {
}

function onhidden () {
}

function showbackside() 
{
  if(flipShown) {

    var front = document.getElementById("front");
    var back  = document.getElementById("back");

    if(window.widget)
      widget.prepareForTransition("ToBack");
	
    front.style.display="none";
    back.style.display="block";
	
    if(window.widget)
      setTimeout ('widget.performTransition();', 0);
				
    document.getElementById('fliprollie').style.display = "none";
  }
}

function selectDone ()
{ 
  var front = document.getElementById("front");
  var back  = document.getElementById("back");
	
  if (window.widget)
    widget.prepareForTransition("ToFront");
	
  front.style.display="block";
  back.style.display="none";
	
  if (window.widget)
    setTimeout ('widget.performTransition();', 0);
	
  document.getElementById('fliprollie').style.display = "none";
  flipShown = true;

  onshown();
}


function enterflip(event)
{
  document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
  document.getElementById('fliprollie').style.display = 'none';
}

function limit_3 (a, b, c) {
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease) {
    return from + (to - from) * ease;
}

var flipAnimation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, element:null, timer:null};

function flipAnimate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-flipAnimation.starttime, 0, flipAnimation.duration);
	
	if (T >= flipAnimation.duration)
	{
		clearInterval (flipAnimation.timer);
		flipAnimation.timer = null;
		flipAnimation.now = flipAnimation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / flipAnimation.duration));
		flipAnimation.now = computeNextFloat (flipAnimation.from, flipAnimation.to, ease);
	}
	
	flipAnimation.element.style.opacity = flipAnimation.now;
}

function mousemove (event)
{
	if (!flipShown)
	{
		// fade in the flip widget
		if (flipAnimation.timer != null)
		{
			clearInterval (flipAnimation.timer);
			flipAnimation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		flipAnimation.duration = 500;
		flipAnimation.starttime = starttime;
		flipAnimation.element = document.getElementById ('flip');
		flipAnimation.timer = setInterval ("flipAnimate();", 13);
		flipAnimation.from = flipAnimation.now;
		flipAnimation.to = 1.0;
		flipAnimate();
		flipShown = true;
	}
}

function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (flipAnimation.timer != null)
		{
			clearInterval (flipAnimation.timer);
			flipAnimation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		flipAnimation.duration = 500;
		flipAnimation.starttime = starttime;
		flipAnimation.element = document.getElementById ('flip');
		flipAnimation.timer = setInterval ("flipAnimate();", 13);
		flipAnimation.from = flipAnimation.now;
		flipAnimation.to = 0.0;
		flipAnimate();
		flipShown = false;
	}
}

function getLocalizedString (key)
{
	try {
		var ret = localizedStrings[key];
		if (ret === undefined)
			ret = key;
		return ret;
	} catch (ex) {}
	
	return key;
}


function clickOnProvider(event)
{
    if (window.widget)
        widget.openURL("http://www.brightlightsoftware.com");
}

if (window.widget) {	
  widget.onhide = onhidden;
  widget.onshow = onshown;
}

function mouseDown(event, id)
{
  buttonPress(id);
}

function buttonPress(buttonTitle)
{
  var  handled = true;
  var  myDate1 = new Date;
  var  myDate2 = new Date;
  var     diff = new Date();
  var timediff;
  var  d,w,m,y;
  var      z,t;
	
  switch (buttonTitle) {
    case "date1_today":
      document.getElementById("date1").value = new Date();
      break;

    case "date2_today":
      document.getElementById("date2").value = new Date();
      break;

    case "op_add":
      myDate1.setTime(Date.parse(document.getElementById("date1").value));
      document.getElementById("date1").value = myDate1;
      myDate2.setTime(Date.parse(document.getElementById("date2").value));
      document.getElementById("date2").value = myDate2;

      t = myDate1.getTime();
      t = t + (parseInt(document.getElementById("days").value) * 86400000);
      t = t + (parseInt(document.getElementById("weeks").value) * 7 * 86400000);
     
      myDate2 = new Date(t);

      d = myDate2.getDate();
      m = myDate2.getMonth() + parseInt(document.getElementById("months").value);
      y = myDate2.getYear() + 1900; 

      while(m > 11) {
        m = m - 12;
        y = y + 1;
      }

      document.getElementById("date2").value = new Date(y, m, d);

      break;

    case "op_sub":
      myDate1.setTime(Date.parse(document.getElementById("date1").value));
      document.getElementById("date1").value = myDate1;
      myDate2.setTime(Date.parse(document.getElementById("date2").value));
      document.getElementById("date2").value = myDate2;

      t = myDate1.getTime();
      t = t - (parseInt(document.getElementById("days").value) * 86400000);
      t = t - (parseInt(document.getElementById("weeks").value) * 7 * 86400000);
     
      myDate2 = new Date(t);

      d = myDate2.getDate();
      m = myDate2.getMonth() - parseInt(document.getElementById("months").value);
      y = myDate2.getYear() + 1900; 

      while(m < 0) {
        m = m + 12;
        y = y - 1;
      }

      document.getElementById("date2").value = new Date(y, m, d);

      break;

   case "switch":
      myDate1.setTime(Date.parse(document.getElementById("date1").value));
      document.getElementById("date1").value = myDate1;
      myDate2.setTime(Date.parse(document.getElementById("date2").value));
      document.getElementById("date2").value = myDate2;

      if(diffShown == 0) {
        diffShown = diffShown + 1;

        diff.setTime(Math.abs(myDate1.getTime() - myDate2.getTime()));

        timediff = diff.getTime();

        w = Math.floor(timediff / (1000 * 60 * 60 * 24 * 7));
        timediff -= w * (1000 * 60 * 60 * 24 * 7);

        z = Math.floor(timediff / (1000 * 60 * 60 * 24)); 
        timediff -= z * (1000 * 60 * 60 * 24);

        document.getElementById('result').innerText = ('difference: ' + z + ' days ' + w + ' weeks ');
        break;      
      }

      if(diffShown == 1) {
        diffShown = diffShown + 1;

        diff.setTime(Math.abs(myDate1.getTime() - myDate2.getTime()));

        timediff = diff.getTime();

        w = 0;

        z = Math.floor(timediff / (1000 * 60 * 60 * 24)); 
        timediff -= z * (1000 * 60 * 60 * 24);

        document.getElementById('result').innerText = ('difference: ' + z + ' days ');
        break;
      }

      diffShown = 0; 

    case "op_dif":
      myDate1.setTime(Date.parse(document.getElementById("date1").value));
      document.getElementById("date1").value = myDate1;
      myDate2.setTime(Date.parse(document.getElementById("date2").value));
      document.getElementById("date2").value = myDate2;

      if(myDate1.getTime() > myDate2.getTime()) {
        var yearNow = myDate1.getYear();
        var monthNow = myDate1.getMonth();
        var dateNow = myDate1.getDate();

        var yearDob = myDate2.getYear();
        var monthDob = myDate2.getMonth();
        var dateDob = myDate2.getDate();
      }
      else {
        var yearNow = myDate2.getYear();
        var monthNow = myDate2.getMonth();
        var dateNow = myDate2.getDate();

        var yearDob = myDate1.getYear();
        var monthDob = myDate1.getMonth();
        var dateDob = myDate1.getDate();
      }

      y = yearNow - yearDob;

      if (monthNow >= monthDob)
        m = monthNow - monthDob;
      else {
        y--;
        m = 12 + monthNow - monthDob;
      }

      if (dateNow >= dateDob)
        d = dateNow - dateDob;
      else {
        m--;
        d = 31 + dateNow - dateDob;

        if (m < 0) {
          m = 11;
          y--; 
        }
      }

      document.getElementById('result').innerText = ('difference: ' + d + ' days ' + m + ' months ' + y + ' years');

      diffShown = false;

      break;

   default:
      handled = false;
      break;
  }
	
  return handled
}
